
local UseSmallField=false	 		-- toggle small or large court here, basketballfield.lua and basketballfieldsmall.lua are the same for the rest

local WakeUpOnPlayers=4				-- toggle at how many found players the field will wake up
local MinimumPlayers=6				-- toggle at how many players the field will start the game
local GoalDistance=5				-- specify distance to goal, if the ball is closer then a goal will be made

local timeTot=0
local numPlayers=0
local numFloor=1
local numLine=0
local FloorTypes = { [1] = "BasketballConcreteFloor", [2] = "BasketballFloor", [3] = "BasketballPavingStone", [4] = "BasketballRoad", [5] = "BasketballWoodenFloor", [6] = "BasketballWoodLaminate", [7] = "BasketballMosaicFloor", [8] = "BasketballMetalFloor", [9] = "BasketballConcreteTiles", [10] = "BasketballDirt", [11] = "BasketballGrass", [12] = "BasketballLongGrass", [13] = "BasketballMud", [14] = "BasketballCeramicFloor", [15] = "BasketballSand", [16] = "BasketballMarbleTiles", [17] = "BasketballWhiteTiles", [18] = "BasketballFancyTiles", [19] = "Dirt" } -- type 19 is used when deleting court
local FloorDescription = { [1] = "tooltip_BasketballConcreteFloor", [2] = "tooltip_BasketballFloor", [3] = "tooltip_BasketballPavingStone", [4] = "tooltip_BasketballRoad", [5] = "tooltip_BasketballWoodenFloor", [6] = "tooltip_BasketballWoodLaminate", [7] = "tooltip_BasketballMosaicFloor", [8] = "tooltip_BasketballMetalFloor", [9] = "tooltip_BasketballConcreteTiles", [10] = "tooltip_BasketballDirt", [11] = "tooltip_BasketballGrass", [12] = "tooltip_BasketballLongGrass", [13] = "tooltip_BasketballMud", [14] = "tooltip_BasketballCeramicFloor", [15] = "tooltip_BasketballSand", [16] = "tooltip_BasketballMarbleTiles", [17] = "tooltip_BasketballWhiteTiles", [18] = "tooltip_BasketballFancyTiles" }
local LightsAreOn=false
local FieldsFound=false
local FieldsFoundL=false
local FieldsFoundR=false
local SpawnBallX=0.00000
local SpawnBallY=0.00000
local BallFound=false
local BallOk=false
local ScoreBoardFound=false
local ScoreFound=false
local ScoreFoundLT=false
local ScoreFoundLU=false
local ScoreDashFound=false
local ScoreFoundRT=false
local ScoreFoundRU=false
local GoalsFound=false
local GoalsFoundL=false
local GoalsFoundR=false
local TeacherFound=false
local BallJobCreated=false

function Create()
	Object.SetProperty(this,"CreateMyField","ON")
	Object.SetProperty(this,"BallKillOrDelete","deleted")
end

----------------------------------------------------------------------------------------------------------------------------------
--  Find my things
----------------------------------------------------------------------------------------------------------------------------------

function FindMyFields()
	FieldsFound=false
	FieldsFoundL=false
	FieldsFoundR=false
	if this.DebugInfo=="ON" then print("Searching for fields...") end
	local leftFields = this.GetNearbyObjects('BasketballFieldLeft',6)
	for thatField, distance in pairs (leftFields) do
		if thatField.HomeUID==this.HomeUID then
			if this.DebugInfo=="ON" then print("Left field found. Don't forget to wire it to the goal") end
			myLeftField=thatField
			myLeftField.Triggered=2
			FieldsFoundL=true
			myLeftField.Tooltip={"tooltip_linktogoal",myLeftField.HomeUID,"X"}
		end
	end
	if this.UsingSmallField==false then
		local rightFields = this.GetNearbyObjects('BasketballFieldRight',6)
		for thatfield, distance in pairs (rightFields) do
			if thatfield.HomeUID==this.HomeUID then
				if this.DebugInfo=="ON" then print("Right field found. Don't forget to wire it to the goal") end
				myRightField=thatfield
				myRightField.Triggered=2
				FieldsFoundR=true
				myRightField.Tooltip={"tooltip_linktogoal",myRightField.HomeUID,"X"}
			end
		end
	end
	if this.UsingSmallField==false then
		if FieldsFoundL==true and FieldsFoundR==true then
			FieldsFound=true
		else
			FindMyGoals()
			DismantleAll()
		end
	else
		if FieldsFoundL==true then
			FieldsFound=true
		else
			FindMyGoals()
			DismantleAll()
		end
	end
end

function FindMyGoals()
	GoalsFound=false
	GoalsFoundL=false
	GoalsFoundR=false
	if this.DebugInfo=="ON" then print("Searching for goals...") end
	local nearbyGoals = this.GetNearbyObjects('StatusLight',7)
	for thatGoal, distance in pairs (nearbyGoals) do
		if thatGoal.HomeUID==this.HomeUID and thatGoal.LeftGoal=="yes" then
			if this.DebugInfo=="ON" then print("Left goal found") end
			myLeftGoal=thatGoal
			GoalsFoundL=true
			myLeftGoal.Triggered=2
			myLeftGoal.Tooltip={"tooltip_linkedto",myLeftGoal.HomeUID,"X"}
		elseif thatGoal.HomeUID==this.HomeUID and thatGoal.RightGoal=="yes" then
			if this.DebugInfo=="ON" then print("Right goal found") end
			myRightGoal=thatGoal
			GoalsFoundR=true
			myRightGoal.Triggered=2
			myRightGoal.Tooltip={"tooltip_linkedto",myRightGoal.HomeUID,"X"}
		end
	end
	if this.UsingSmallField==false then
		if GoalsFoundL==true and GoalsFoundR==true then GoalsFound=true
		else
			DismantleAll()
		end
	else
		if GoalsFoundL==true then GoalsFound=true
		else
			DismantleAll()
		end
	end
end

function FindMyCourtLights()
	if this.DebugInfo=="ON" then print("Searching for court lights...") end
	myFieldLights={}
	local nearbyLights = this.GetNearbyObjects('Light',10)
	local i=1
	if next(nearbyLights) then
		for thatLight, distance in pairs (nearbyLights) do
			if thatLight.HomeUID==this.HomeUID then
				if this.UsingSmallField==true then
					if this.Or.x==0 and this.Or.y==1 and thatLight.Pos.x==this.Pos.x-0.2 and thatLight.Pos.y==this.Pos.y then
						if this.DebugInfo=="ON" then print("Found centre circle light") end
						myCentreLight=thatLight
					end	-- placed down
					if this.Or.x==-1 and this.Or.y==0 and thatLight.Pos.x==this.Pos.x and thatLight.Pos.y==this.Pos.y-0.2 then
						if this.DebugInfo=="ON" then print("Found centre circle light") end
						myCentreLight=thatLight
					end	-- rotated once
					if this.Or.x==0 and this.Or.y==-1 and thatLight.Pos.x==this.Pos.x+0.2 and thatLight.Pos.y==this.Pos.y then
						if this.DebugInfo=="ON" then print("Found centre circle light") end
						myCentreLight=thatLight
					end	-- rotated twice
					if this.Or.x==1 and this.Or.y==0 and thatLight.Pos.x==this.Pos.x and thatLight.Pos.y==this.Pos.y+0.2 then
						if this.DebugInfo=="ON" then print("Found centre circle light") end
						myCentreLight=thatLight
					end	-- rotated three times
				elseif thatLight.Pos.x==this.Pos.x and thatLight.Pos.y==this.Pos.y then
					if this.DebugInfo=="ON" then print("Found centre circle light") end
					myCentreLight=thatLight
				else
					myFieldLights[i] = thatLight
					if this.DebugInfo=="ON" then print("Found court light "..i.."") end
					i=i+1
					LightsAreOn=true
				end
			end
		end
	else
		if this.DebugInfo=="ON" then print("Court lights not found") end
	end
end

function FindMyScoreBoard()
	if this.DebugInfo=="ON" then print("Searching for scoreboard...") end
	ScoreFound=false
	ScoreFoundLT=false
	ScoreFoundLU=false
	ScoreFoundRT=false
	ScoreFoundRU=false
	local nearbyScores = this.GetNearbyObjects('LEDNumber',15)
	if next(nearbyScores) then
		for thatScore, distance in pairs (nearbyScores) do
			if thatScore.HomeUID==this.HomeUID or thatScore.HomeUID==0 then
				if thatScore.LeftGoal=="yes" and thatScore.PlaceValue=="Tens" then
					if this.DebugInfo=="ON" then print("Left scoreboard found (tens)") end
					myLeftScoreTens=thatScore
					ScoreFoundLT=true
				end
				if thatScore.LeftGoal=="yes" and thatScore.PlaceValue=="Units" then
					if this.DebugInfo=="ON" then print("Left scoreboard found (units)") end
					myLeftScoreUnits=thatScore
					ScoreFoundLU=true
				end
				if thatScore.RightGoal=="yes" and thatScore.PlaceValue=="Tens" then
					if this.DebugInfo=="ON" then print("Right scoreboard found (tens)") end
					myRightScoreTens=thatScore
					ScoreFoundRT=true
				end
				if thatScore.RightGoal=="yes" and thatScore.PlaceValue=="Units" then
					if this.DebugInfo=="ON" then print("Right scoreboard found (units)") end
					myRightScoreUnits=thatScore
					ScoreFoundRU=true
				end
				if thatScore.RightGoal=="yes" and thatScore.PlaceValue=="Dash" then
					if this.DebugInfo=="ON" then print("Score dash found") end
					myScoreDash=thatScore
					ScoreDashFound=true
				end
			end
		end
	end
	if this.UsingSmallField==false then
		local nearbyScoreBoards = this.GetNearbyObjects('ScoreBoard',15)
		if next(nearbyScoreBoards) then
			for thatScoreBoard, distance in pairs (nearbyScoreBoards) do
				if thatScoreBoard.HomeUID==this.HomeUID or thatScoreBoard.HomeUID==0 then
					myScoreBoard=thatScoreBoard
					Object.SetProperty(myScoreBoard,"HomeUID",this.HomeUID)
					myScoreBoard.Tooltip={"tooltip_linkscoreboard",myScoreBoard.HomeUID,"X"}
					ScoreBoardFound=true
				end
			end
		end
		if ScoreFoundLT==true and ScoreFoundLU==true and ScoreFoundRT==true and ScoreFoundRU==true then
			ScoreFound=true
			Object.SetProperty(myLeftScoreTens,"HomeUID",this.HomeUID);		myLeftScoreTens.Tooltip={"tooltip_linkedto",myLeftScoreTens.HomeUID,"X"}
			Object.SetProperty(myLeftScoreUnits,"HomeUID",this.HomeUID);	myLeftScoreUnits.Tooltip={"tooltip_linkedto",myLeftScoreUnits.HomeUID,"X"}
			Object.SetProperty(myRightScoreTens,"HomeUID",this.HomeUID);	myRightScoreTens.Tooltip={"tooltip_linkedto",myRightScoreTens.HomeUID,"X"}
			Object.SetProperty(myRightScoreUnits,"HomeUID",this.HomeUID);	myRightScoreUnits.Tooltip={"tooltip_linkedto",myRightScoreUnits.HomeUID,"X"}
			
			if ScoreDashFound==true then
				Object.SetProperty(myScoreDash,"HomeUID",this.HomeUID)
				myScoreDash.Tooltip={"tooltip_linkedto",myScoreDash.HomeUID,"X"}
			end
			
			if this.LeftScore<10 then  --the scoreboard can count up to 59 wohoo!
				Object.SetProperty(myLeftScoreTens,"SubType",0)		Object.SetProperty(myLeftScoreUnits,"SubType",this.LeftScore)
			elseif this.LeftScore<20 then
				Object.SetProperty(myLeftScoreTens,"SubType",1)		Object.SetProperty(myLeftScoreTens,"myScore",1)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-10)
			elseif this.LeftScore<30 then
				Object.SetProperty(myLeftScoreTens,"SubType",2)		Object.SetProperty(myLeftScoreTens,"myScore",2)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-20)
			elseif this.LeftScore<40 then
				Object.SetProperty(myLeftScoreTens,"SubType",3)		Object.SetProperty(myLeftScoreTens,"myScore",3)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-30)
			elseif this.LeftScore<50 then
				Object.SetProperty(myLeftScoreTens,"SubType",4)		Object.SetProperty(myLeftScoreTens,"myScore",4)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-40)
			elseif this.LeftScore<60 then
				Object.SetProperty(myLeftScoreTens,"SubType",5)		Object.SetProperty(myLeftScoreTens,"myScore",5)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-50)
			end
			if this.RightScore<10 then
				Object.SetProperty(myRightScoreTens,"SubType",0)	Object.SetProperty(myRightScoreUnits,"SubType",this.RightScore)
			elseif this.RightScore<20 then
				Object.SetProperty(myRightScoreTens,"SubType",1)	Object.SetProperty(myRightScoreTens,"myScore",1)		Object.SetProperty(myRightScoreUnits,"SubType",this.RightScore-10)
			elseif this.RightScore<30 then
				Object.SetProperty(myRightScoreTens,"SubType",2)	Object.SetProperty(myRightScoreTens,"myScore",2)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-20)
			elseif this.RightScore<40 then
				Object.SetProperty(myRightScoreTens,"SubType",3)	Object.SetProperty(myRightScoreTens,"myScore",3)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-30)
			elseif this.RightScore<50 then
				Object.SetProperty(myRightScoreTens,"SubType",4)	Object.SetProperty(myRightScoreTens,"myScore",4)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-40)
			elseif this.RightScore<60 then
				Object.SetProperty(myRightScoreTens,"SubType",5)	Object.SetProperty(myRightScoreTens,"myScore",5)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-50)
			end
			local digitOne=string.sub(tostring(this.HomeUID),-4,-4)
			local digitTwo=string.sub(tostring(this.HomeUID),-3,-3)
			local digitThree=string.sub(tostring(this.HomeUID),-2,-2)
			local digitFour=string.sub(tostring(this.HomeUID),-1,-1)
			Object.SetProperty(mRightScoreTens,"myDigit",digitOne)
			Object.SetProperty(myRightScoreUnits,"myDigit",digitTwo)
			Object.SetProperty(myLeftScoreTens,"myDigit",digitThree)
			Object.SetProperty(myLeftScoreUnits,"myDigit",digitFour)
		--	Object.SetProperty(myLeftScoreTens,"myScore",myLeftScoreTens.SubType)
		--	Object.SetProperty(myLeftScoreUnits,"myScore",myLeftScoreUnits.SubType)
		--	Object.SetProperty(myRightScoreTens,"myScore",myRightScoreTens.SubType)
		--	Object.SetProperty(myRightScoreUnits,"myScore",myRightScoreUnits.SubType)
		--	Object.SetProperty(myLeftScoreTens,"SubType",digitOne)
		--	Object.SetProperty(myLeftScoreUnits,"SubType",digitTwo)
		--	Object.SetProperty(myRightScoreTens,"SubType",digitThree)
		--	Object.SetProperty(myRightScoreUnits,"SubType",digitFour)
			Object.SetProperty(myLeftScoreTens,"ShowCourtUID",true)
			Object.SetProperty(myLeftScoreUnits,"ShowCourtUID",true)
			Object.SetProperty(myRightScoreTens,"ShowCourtUID",true)
			Object.SetProperty(myRightScoreUnits,"ShowCourtUID",true)
		--	Object.SetProperty(myLeftScoreTens,"timePerUpdate",3)
		--	Object.SetProperty(myLeftScoreUnits,"timePerUpdate",3)
		--	Object.SetProperty(myRightScoreTens,"timePerUpdate",3)
		--	Object.SetProperty(myRightScoreUnits,"timePerUpdate",3)
			
			if this.DebugInfo=="ON" then print("               Score: "..this.LeftScore.." - "..this.RightScore.."") end
		end
	else
		if ScoreFoundLT==true and ScoreFoundLU==true then
			ScoreFound=true
			Object.SetProperty(myLeftScoreTens,"HomeUID",this.HomeUID);		myLeftScoreTens.Tooltip={"tooltip_linkedto",myLeftScoreTens.HomeUID,"X"}
			Object.SetProperty(myLeftScoreUnits,"HomeUID",this.HomeUID);	myLeftScoreUnits.Tooltip={"tooltip_linkedto",myLeftScoreUnits.HomeUID,"X"}
			
			if this.LeftScore<10 then
				Object.SetProperty(myLeftScoreTens,"SubType",0)				Object.SetProperty(myLeftScoreUnits,"SubType",this.LeftScore)
			elseif this.LeftScore<20 then
				Object.SetProperty(myLeftScoreTens,"SubType",1)		Object.SetProperty(myLeftScoreTens,"myScore",1)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-10)
			elseif this.LeftScore<30 then
				Object.SetProperty(myLeftScoreTens,"SubType",2)		Object.SetProperty(myLeftScoreTens,"myScore",2)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-20)
			elseif this.LeftScore<40 then
				Object.SetProperty(myLeftScoreTens,"SubType",3)		Object.SetProperty(myLeftScoreTens,"myScore",3)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-30)
			elseif this.LeftScore<50 then
				Object.SetProperty(myLeftScoreTens,"SubType",4)		Object.SetProperty(myLeftScoreTens,"myScore",4)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-40)
			elseif this.LeftScore<60 then
				Object.SetProperty(myLeftScoreTens,"SubType",5)		Object.SetProperty(myLeftScoreTens,"myScore",5)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-50)
			end
			local digitOne=string.sub(tostring(this.HomeUID),-2,-2)
			local digitTwo=string.sub(tostring(this.HomeUID),-1,-1)
			Object.SetProperty(myLeftScoreTens,"myDigit",digitOne)
			Object.SetProperty(myLeftScoreUnits,"myDigit",digitTwo)
		--	Object.SetProperty(myLeftScoreTens,"myScore",myLeftScoreTens.SubType)
		--	Object.SetProperty(myLeftScoreUnits,"myScore",myLeftScoreUnits.SubType)
		--	Object.SetProperty(myLeftScoreTens,"SubType",digitOne)
		--	Object.SetProperty(myLeftScoreUnits,"SubType",digitTwo)
			Object.SetProperty(myLeftScoreTens,"ShowCourtUID",true)
			Object.SetProperty(myLeftScoreUnits,"ShowCourtUID",true)
		--	Object.SetProperty(myLeftScoreTens,"timePerUpdate",3)
		--	Object.SetProperty(myLeftScoreUnits,"timePerUpdate",3)
			if this.DebugInfo=="ON" then print("               Score: "..this.LeftScore.."") end
		end
	end	
end

function FindMyBall()
	BallFound=false
	BallOk=false
	if this.DebugInfo=="ON" then print("Searching for ball...") end
	local theBall = this.GetNearbyObjects('Basketball',11)
	if next(theBall) then
		for thatBall, distance in pairs (theBall) do
			if thatBall.HomeUID==this.HomeUID and thatBall.Damage==0 then
				if BallOk==false then
					myBall=thatBall
					BallOk=true
					if this.DebugInfo=="ON" then print("Ball found") end
				else
					if this.BallKillOrDelete=="deleted" then
						if this.DebugInfo=="ON" then print("Deleting obsolete basketball") end		thatBall.Delete()
					else
						if this.DebugInfo=="ON" then print("Killing obsolete basketball") end		thatBall.Damage=1
					end
				end
			else
				if this.BallKillOrDelete=="deleted" then
					if this.DebugInfo=="ON" then print("Deleting obsolete basketball") end			thatBall.Delete()
				else
					if this.DebugInfo=="ON" then print("Killing obsolete basketball") end			thatBall.Damage=1
				end
			end
		end
	end
	if BallOk==true then BallFound=true elseif this.DebugInfo=="ON" then print("Ball not found") end
end

----------------------------------------------------------------------------------------------------------------------------------
--  Court Lights
----------------------------------------------------------------------------------------------------------------------------------

function LightsOn()
	if LightsAreOn==false then
		myFieldLights={}
		if this.DebugInfo=="ON" then print("Turning court lights on") end
		if this.UsingSmallField==false then
			if this.Or.x==0 then				-- horizontal court
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y-4.8)	myFieldLights[2] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y+4.8)
				myFieldLights[3] = Object.Spawn("Light", this.Pos.x,this.Pos.y-4.8)			myFieldLights[4] = Object.Spawn("Light", this.Pos.x,this.Pos.y+4.8)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y-4.8)	myFieldLights[6] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y+4.8)
				myFieldLights[7] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y)		myFieldLights[8] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y)
			elseif this.Or.y==0 then 			-- vertical court
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x-4.80000,this.Pos.y-7.8)	myFieldLights[2] = Object.Spawn("Light", this.Pos.x-4.80000,this.Pos.y+7.8)
				myFieldLights[3] = Object.Spawn("Light", this.Pos.x,this.Pos.y-7.8)			myFieldLights[4] = Object.Spawn("Light", this.Pos.x,this.Pos.y+7.8)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x+4.80000,this.Pos.y-7.8)	myFieldLights[6] = Object.Spawn("Light", this.Pos.x+4.80000,this.Pos.y+7.8)
				myFieldLights[7] = Object.Spawn("Light", this.Pos.x-4.80000,this.Pos.y)		myFieldLights[8] = Object.Spawn("Light", this.Pos.x+4.80000,this.Pos.y)
			end
			for i=1,8 do
				Object.SetProperty(myFieldLights[i],"HomeUID",this.HomeUID)
			end
		else
			if this.Or.x==0 and this.Or.y==1 then -- placed down
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y-4.8)	myFieldLights[2] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y+4.8)
				myFieldLights[4] = Object.Spawn("Light", this.Pos.x-0.2,this.Pos.y+4.8)		myFieldLights[3] = Object.Spawn("Light", this.Pos.x-0.2,this.Pos.y-4.8)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x-7.80000,this.Pos.y)		myFieldLights[6] = Object.Spawn("Light", this.Pos.x-0.2,this.Pos.y)
			elseif this.Or.x==-1 and this.Or.y==0 then -- rotated once
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x-4.8,this.Pos.y-7.8)		myFieldLights[2] = Object.Spawn("Light", this.Pos.x+4.8,this.Pos.y-7.8)
				myFieldLights[4] = Object.Spawn("Light", this.Pos.x,this.Pos.y-7.8)			myFieldLights[3] = Object.Spawn("Light", this.Pos.x,this.Pos.y-0.2)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x-4.8,this.Pos.y-0.2)		myFieldLights[6] = Object.Spawn("Light", this.Pos.x+4.8,this.Pos.y-0.2)
			elseif this.Or.x==0 and this.Or.y==-1 then -- rotated twice
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y-4.8)	myFieldLights[2] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y+4.8)
				myFieldLights[4] = Object.Spawn("Light", this.Pos.x+0.2,this.Pos.y+4.8)		myFieldLights[3] = Object.Spawn("Light", this.Pos.x+0.2,this.Pos.y-4.8)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x+7.80000,this.Pos.y)		myFieldLights[6] = Object.Spawn("Light", this.Pos.x+0.2,this.Pos.y)
			elseif this.Or.x==1 and this.Or.y==0 then -- rotated three times
				myFieldLights[1] = Object.Spawn("Light", this.Pos.x-4.8,this.Pos.y+7.8)		myFieldLights[2] = Object.Spawn("Light", this.Pos.x+4.8,this.Pos.y+7.8)
				myFieldLights[4] = Object.Spawn("Light", this.Pos.x,this.Pos.y+7.8)			myFieldLights[3] = Object.Spawn("Light", this.Pos.x,this.Pos.y+0.2)
				myFieldLights[5] = Object.Spawn("Light", this.Pos.x-4.8,this.Pos.y+0.2)		myFieldLights[6] = Object.Spawn("Light", this.Pos.x+4.8,this.Pos.y+0.2)
			end
			for i=1,6 do
				Object.SetProperty(myFieldLights[i],"HomeUID",this.HomeUID)
			end
		end
		LightsAreOn=true
		Object.SetProperty(this,"CourtLights","ON")
		this.SetInterfaceCaption("toggleCourtLights", "tooltip_button_courtlights","tooltip_on","X")
	end
end

function LightsOff()
	if this.DebugInfo=="ON" then print("Turning court lights off") end
	for i=1,8 do
		if myFieldLights[i]~=nil then
			myFieldLights[i].Delete()
		end
	end
	myFieldLights={}
	Object.SetProperty(this,"CourtLights","OFF")
	this.SetInterfaceCaption("toggleCourtLights", "tooltip_button_courtlights","tooltip_off","X")
	LightsAreOn=false
end

----------------------------------------------------------------------------------------------------------------------------------
--  Ball stuff
----------------------------------------------------------------------------------------------------------------------------------

function SpawnNewBall(DribbleCounter)  -- 0=dribble, 5=don't dribble at spawn
	if this.DebugInfo=="ON" then print("Spawning a new basketball") end
	myBall = Object.Spawn("Basketball", SpawnBallX,SpawnBallY)
	Object.SetProperty(myBall,"HomeUID",this.HomeUID)
	Object.SetProperty(myBall,"NewPosX","")
	Object.SetProperty(myBall,"NewPosY","")
	Object.SetProperty(myBall,"Energy",100)
	Object.SetProperty(myBall,"Dribble",DribbleCounter)
	Object.SetProperty(myBall,"LinkMeTo","BasketballTrainer")
	Object.SetProperty(myBall,"NewPlayerI",myTeacher.Id.i)
	Object.SetProperty(myBall,"NewPlayerU",myTeacher.Id.u)
	BallFound=true
end
	
function BounceBall() -- if ball is carried by player (= arrived) then do next action, otherwise do nothing and wait for the ball to arrive at its target
	if Object.GetProperty(myBall,"Carried")>0 and this.LeftGoalMade==false and this.RightGoalMade==false then
		if myCurrentPlayer~=nil then myPriorPlayer=myCurrentPlayer.Id.i end
		myCurrentPlayer=myNewPlayer
		if this.DebugInfo=="ON" then print("               Removing carried from "..myCurrentPlayer.Id.i.."") end
		Object.SetProperty(myBall,"Carried",0)						Object.SetProperty(myBall,"Energy",100)
		Object.SetProperty(myBall,"NewPosX","")						Object.SetProperty(myBall,"NewPosY","")
		Object.SetProperty(myBall,"CarrierId.i",0)					Object.SetProperty(myBall,"CarrierId.u",0)
		Object.SetProperty(myCurrentPlayer,"Carrying.i",0)			Object.SetProperty(myCurrentPlayer,"Carrying.u",0)
	--	Object.SetProperty(myBall,"Pos.x",myCurrentPlayer.Pos.x)
		Object.SetProperty(myBall,"Pos.y",myCurrentPlayer.Pos.y+0.2)
		Object.SetProperty(myBall,"Dribble",0)
		
		local dX1 = myCurrentPlayer.Pos.x
		local dX2 = myLeftGoal.Pos.x
		local dY1 = myCurrentPlayer.Pos.y
		local dY2 = myLeftGoal.Pos.y
		leftGoalDistance = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
		local rndX = math.random()
		if rndX >= .33 then doShot=true else doShot=false end
		--if this.UsingSmallField==true then
		--	if this.Or.x==0 and this.Or.y==1 then
			--	leftGoalDistance=myCurrentPlayer.Pos.x-myLeftGoal.Pos.x
		--	end	-- placed down
		--	if this.Or.x==-1 and this.Or.y==0 then
			--	leftGoalDistance=myCurrentPlayer.Pos.y-myLeftGoal.Pos.y
		--	end	-- rotated once
		--	if this.Or.x==0 and this.Or.y==-1 then
			--	leftGoalDistance=myLeftGoal.Pos.x-myCurrentPlayer.Pos.x
		--	end	-- rotated twice
		--	if this.Or.x==1 and this.Or.y==0 then
			--	leftGoalDistance=myLeftGoal.Pos.y-myCurrentPlayer.Pos.y
		--	end	-- rotated three times
		--else
		--	if this.Or.x==0 then
			--	leftGoalDistance=myCurrentPlayer.Pos.x-myLeftGoal.Pos.x
		--	end	-- placed down
		--	if this.Or.y==0 then
		--		leftGoalDistance=myCurrentPlayer.Pos.y-myLeftGoal.Pos.y
		--	end	-- rotated once
		--end
		
		if this.DebugInfo=="ON" then print("Left goal distance: "..leftGoalDistance.."") end
		
		if leftGoalDistance<=GoalDistance and doShot==true then
			Object.SetProperty(myBall,"NewPosX",myLeftGoal.Pos.x)		Object.SetProperty(myBall,"NewPosY",myLeftGoal.Pos.y)
			Object.SetProperty(myBall,"NewPlayerI",myLeftGoal.Id.i)		Object.SetProperty(myBall,"NewPlayerU",myLeftGoal.Id.u)
			Object.SetProperty(myBall,"LinkMeTo","StatusLight")			Object.SetProperty(this,"LeftGoalMade",true)
		end
		
		if this.UsingSmallField==false then

			local dX1 = myCurrentPlayer.Pos.x
			local dX2 = myRightGoal.Pos.x
			local dY1 = myCurrentPlayer.Pos.y
			local dY2 = myRightGoal.Pos.y
			rightGoalDistance = math.sqrt((dX2-dX1)^2+(dY2-dY1)^2)
			local rndX = math.random()
			if rndX >= .33 then doShot=true else doShot=false end
		--	if this.Or.x==0 then rightGoalDistance=myRightGoal.Pos.x-myCurrentPlayer.Pos.x end
		--	if this.Or.y==0 then rightGoalDistance=myRightGoal.Pos.y-myCurrentPlayer.Pos.y end

			if this.DebugInfo=="ON" then print("Right goal distance: "..rightGoalDistance.."") end
			if rightGoalDistance<=GoalDistance and doShot==true then
				Object.SetProperty(myBall,"NewPosX",myRightGoal.Pos.x)		Object.SetProperty(myBall,"NewPosY",myRightGoal.Pos.y)
				Object.SetProperty(myBall,"NewPlayerI",myRightGoal.Id.i)	Object.SetProperty(myBall,"NewPlayerU",myRightGoal.Id.u)
				Object.SetProperty(myBall,"LinkMeTo","StatusLight")			Object.SetProperty(this,"RightGoalMade",true)
			end
		end
		
		if this.LeftGoalMade==false and this.RightGoalMade==false then
			FindMyPlayer()
			if this.DebugInfo=="ON" then print("               Navigating to "..myNewPlayer.Id.i.."") end
			if myNewPlayer.Id.i==myTeacher.Id.i then
				Object.SetProperty(myBall,"LinkMeTo","BasketballTrainer")
			else
				Object.SetProperty(myBall,"LinkMeTo","Prisoner")
			end
			Object.SetProperty(myBall,"NewPosX",myNewPlayer.Pos.x)			Object.SetProperty(myBall,"NewPosY",myNewPlayer.Pos.y)
			Object.SetProperty(myBall,"NewPlayerI",myNewPlayer.Id.i)		Object.SetProperty(myBall,"NewPlayerU",myNewPlayer.Id.u)
			
			Object.NavigateTo(myNewPlayer,myNewPlayer.Pos.x, myNewPlayer.Pos.y)
			myNewPlayer.ClearRouting()
			Object.SetProperty(this,"TickTockTimer",1)
		end
	end
end

----------------------------------------------------------------------------------------------------------------------------------
--  Player stuff
----------------------------------------------------------------------------------------------------------------------------------

function CheckNumPlayers()
	Object.SetProperty(this,"TickTockTimer",this.TickTockTimer+1)
	if this.DebugInfo=="ON" then print("                                             Finding players on court...") end
	numPlayers=0
	local possiblePlayers = this.GetNearbyObjects('Prisoner',10)
	if next(possiblePlayers) then
		for thatprisoner,dist in pairs( possiblePlayers ) do
			if (thatprisoner.Pos.x>=this.Pos.x+this.Xmin-2 and thatprisoner.Pos.x<=this.Pos.x+this.Xmax+2) and (thatprisoner.Pos.y>=this.Pos.y+this.Ymin-2 and thatprisoner.Pos.y<=this.Pos.y+this.Ymax+2) then
				numPlayers=numPlayers+1
			end
		end
		if numPlayers==0 then
			DoSleepMode()
		else
			if this.DebugInfo=="ON" then print("                                             "..(numPlayers).." players found on court ("..MinimumPlayers.." required)") end
			this.Tooltip={"tooltip_playersfoundandrequired",this.HomeUID,"X",numPlayers,"Y",MinimumPlayers,"Z"}
			DecideWhatToDo()
		end -- either sleep or check if teacher has stuff to do before bounceball() gets called in update()
	else
		DoSleepMode()
	end
end

function FindMyPlayer()
	if this.DebugInfo=="ON" then print("               Finding next player...") end
	myNewPlayer=myTeacher -- in case the game ends and there are no new players it could crash if myNewPlayer stays empty, so we make it the teacher by default.
	if myCurrentPlayer==nil then
		somePlayers = this.GetNearbyObjects('Prisoner',10)
	else
		somePlayers = Object.GetNearbyObjects(myCurrentPlayer,'Prisoner',10)
	end
	if next(somePlayers) then
		local currentDist=20
		for thatprisoner,dist in pairs( somePlayers ) do
			if (thatprisoner.Pos.x>=this.Pos.x+this.Xmin-1 and thatprisoner.Pos.x<=this.Pos.x+this.Xmax+1) and (thatprisoner.Pos.y>=this.Pos.y+this.Ymin-1 and thatprisoner.Pos.y<=this.Pos.y+this.Ymax+1) then
				if dist < currentDist and dist > 2 then
					currentDist=dist
					if myCurrentPlayer~=nil then
						if myCurrentPlayer.Id.i~=thatprisoner.Id.i and thatprisoner.Id.i~=myPriorPlayer then
							myNewPlayer=thatprisoner
							if this.DebugInfo=="ON" then print("               Nearest player "..myNewPlayer.Id.i.." is at dist: "..math.floor(currentDist).." Position: "..myNewPlayer.Pos.x.." "..myNewPlayer.Pos.y.."") end
						end
					else
						myNewPlayer=thatprisoner
						if this.DebugInfo=="ON" then print("               Nearest player "..myNewPlayer.Id.i.." is at dist: "..math.floor(currentDist).." Position: "..myNewPlayer.Pos.x.." "..myNewPlayer.Pos.y.."") end
					end
				end
			end
		end
		if this.DebugInfo=="ON" then print("               Next player: "..myNewPlayer.Id.i.."") end
	end
end

----------------------------------------------------------------------------------------------------------------------------------
--  Teacher stuff
----------------------------------------------------------------------------------------------------------------------------------

function FindMyTeacher()
	if this.DebugInfo=="ON" then print("Searching for Basketball Trainer...") end
	local nearbyTeachers = this.GetNearbyObjects('BasketballTrainer', 9)
	if next(nearbyTeachers) then
		for thatTeacher,dist in pairs( nearbyTeachers ) do
			if (thatTeacher.Pos.x>=this.Pos.x+this.Xmin-2 and thatTeacher.Pos.x<=this.Pos.x+this.Xmax+2) and (thatTeacher.Pos.y>=this.Pos.y+this.Ymin-2 and thatTeacher.Pos.y<=this.Pos.y+this.Ymax+2) then
				myTeacher = thatTeacher
				if this.DebugInfo=="ON" then print("Basketball Trainer found") end
				TeacherFound=true
			end
		end
		if BallFound==false and TeacherFound==true then
			SpawnBallX=myTeacher.Pos.x
			SpawnBallY=myTeacher.Pos.y+0.1
			SpawnNewBall(0)
		end
		Object.SetProperty(this,"TickTockTimer",4)
	else
		if this.DebugInfo=="ON" then print("Basketball Trainer not found") end
	end
end

function TeacherStartsGame()
	if (myTeacher.Pos.x>=this.Pos.x-2 and myTeacher.Pos.x<=this.Pos.x+2) and (myTeacher.Pos.y>=this.Pos.y-2 and myTeacher.Pos.y<=this.Pos.y+2) then
		if this.DebugInfo=="ON" then print("Basketball Trainer starting the game...") end
		
		Object.SetProperty(myBall,"Energy",100)			Object.SetProperty(myBall,"Carried",0)
		Object.SetProperty(myBall,"NewPosX","")			Object.SetProperty(myBall,"NewPosY","")
		Object.SetProperty(myBall,"CarrierId.i",0)		Object.SetProperty(myBall,"CarrierId.u",0)
	--	Object.SetProperty(myBall,"Pos.x",myTeacher.Pos.x)
		Object.SetProperty(myBall,"Pos.y",myTeacher.Pos.y+0.2)
		Object.SetProperty(myBall,"Dribble",0)
		
		Object.SetProperty(myTeacher,"Carrying.i",0)	Object.SetProperty(myTeacher,"Carrying.u",0)
		
		this.Sound("BasketballCourt","WhistleA")
	
		Object.SetProperty(this,"hasStarted",true)
		Object.SetProperty(this,"LeftGoalMade",false)	Object.SetProperty(this,"RightGoalMade",false)
		Object.SetProperty(this,"TickTockTimer",1)	--	Object.SetProperty(this,"timePerUpdate",1)
		
		FindMyPlayer()
		if this.DebugInfo=="ON" then print("Playing ball to first player") end
		Object.SetProperty(myBall,"LinkMeTo","Prisoner")
		Object.SetProperty(myBall,"NewPosX",myNewPlayer.Pos.x)		Object.SetProperty(myBall,"NewPosY",myNewPlayer.Pos.y)
		Object.SetProperty(myBall,"NewPlayerI",myNewPlayer.Id.i)	Object.SetProperty(myBall,"NewPlayerU",myNewPlayer.Id.u)
		
		Object.NavigateTo(myNewPlayer,myNewPlayer.Pos.x, myNewPlayer.Pos.y)
		Object.SetProperty(this,"TeacherStartingGame",false)
	end
end

function TeacherBringBallToCentre()
	if Object.GetProperty(myBall,"Carried")>0 then
		if this.DebugInfo=="ON" then print("Basketball Trainer placing ball in centre...") end
		myTeacher.ClearRouting()
		if this.UsingSmallField==true then
			if this.Or.x==0 and this.Or.y==1 then
				Object.NavigateTo(myTeacher, this.Pos.x-1, this.Pos.y)
			end	-- placed down
			if this.Or.x==-1 and this.Or.y==0 then
				Object.NavigateTo(myTeacher, this.Pos.x, this.Pos.y-1)
			end	-- rotated once
			if this.Or.x==0 and this.Or.y==-1 then
				Object.NavigateTo(myTeacher, this.Pos.x+1, this.Pos.y)
			end	-- rotated twice
			if this.Or.x==1 and this.Or.y==0 then
				Object.NavigateTo(myTeacher, this.Pos.x, this.Pos.y+1)
			end	-- rotated three times
		else
			Object.NavigateTo(myTeacher, this.Pos.x, this.Pos.y)
		end		
		Object.SetProperty(this,"TickTockTimer",1)	Object.SetProperty(this,"TeacherBringToCentre",false)	Object.SetProperty(this,"TeacherStartingGame",true)
	else
		TeacherFetchBall()
	end
end

function TeacherFetchBall()
	if this.DebugInfo=="ON" then print("Basketball Trainer fetching ball...") end
	
	Object.SetProperty(myBall,"Loaded",false)
	Object.SetProperty(myLeftGoal,"Slot0.i",0)					Object.SetProperty(myRightGoal,"Slot0.i",0)
	Object.SetProperty(myLeftGoal,"Slot0.u",0)					Object.SetProperty(myRightGoal,"Slot0.u",0)
	
	Object.SetProperty(myBall,"LinkMeTo","BasketballTrainer")
	Object.SetProperty(myBall,"Energy",100)						Object.SetProperty(myBall,"Carried",0)
	Object.SetProperty(myBall,"CarrierId.i",0)					Object.SetProperty(myBall,"CarrierId.u",0)
	Object.SetProperty(myBall,"NewPosX",myBall.Pos.x)			Object.SetProperty(myBall,"NewPosY",myBall.Pos.y)
	Object.SetProperty(myBall,"NewPlayerI",myTeacher.Id.i)		Object.SetProperty(myBall,"NewPlayerU",myTeacher.Id.u)
	
	myTeacher.ClearRouting()
	Object.NavigateTo(myTeacher, myBall.Pos.x, myBall.Pos.y)
	myCurrentPlayer=nil
	Object.SetProperty(this,"TickTockTimer",1)				Object.SetProperty(this,"TeacherBringToCentre",true)
end

----------------------------------------------------------------------------------------------------------------------------------
--  Decide
----------------------------------------------------------------------------------------------------------------------------------

function DecideWhatToDo()

	if numPlayers>WakeUpOnPlayers and this.StillAsleep==true then
		LightsOn()
		timePerUpdate=2
		if TeacherFound==false then	FindMyTeacher()	end
	end
	
	if numPlayers>=MinimumPlayers and TeacherFound==true and this.StillAsleep==true then
	
			DoWakeUpMode()

	elseif numPlayers>=MinimumPlayers and TeacherFound==true and this.StillAsleep==false then
		-- the teacher can't do the three functions below in one turn, so it goes step by step while update() waits a few moments in between to give the teacher time to navigate
		if TeacherFound==true and this.TickTockTimer>=4 and this.hasStarted==false then
			TeacherFetchBall()
		elseif TeacherFound==true and this.TeacherBringToCentre==true then
			TeacherBringBallToCentre()			
		elseif TeacherFound==true and this.TeacherStartingGame==true then
			TeacherStartsGame()
		--else
			--if this.DebugInfo=="ON" then print("Nothing to be done by teacher") end
		end
		
	elseif numPlayers<WakeUpOnPlayers and this.StillAsleep==false then
		DoSleepMode()
	end
	
end

----------------------------------------------------------------------------------------------------------------------------------
--  Create stuff
----------------------------------------------------------------------------------------------------------------------------------

function MakeFloor(FloorType)
	local x = math.floor(this.Pos.x)	local y = math.floor(this.Pos.y)
	if FloorType~="Dirt" then
		for i=this.Ymin-1,this.Ymax+1 do	for j=this.Xmin-1,this.Xmax+1 do	local cell = World.GetCell(x+j,y+i)	cell.Mat = "ConcreteTiles"	end	end
		for i=this.Ymin,this.Ymax do		for j=this.Xmin,this.Xmax do		local cell = World.GetCell(x+j,y+i)	cell.Mat = FloorType		end	end
	else -- deleted court, resetting floor to concrete if indoor or dirt if outdoor
		for i=this.Ymin-1,this.Ymax+1 do	for j=this.Xmin-1,this.Xmax+1 do	local cell = World.GetCell(x+j,y+i)	if cell.Ind==true then cell.Mat = "ConcreteFloor" else cell.Mat = "Dirt" end 	end	end
	end
end

-- default placement Down: orX 0 orY 1
-- Left: orX -1 orY 0
-- Up : orX 0 orY -1
-- Right: orX 1 orY 0

function CreateMyField()
	--print("Or.x "..this.Or.x.." Or.y "..this.Or.y.."")
	Object.SetProperty(this,"HomeUID",me["id-uniqueId"])
	this.Tooltip={"tooltip_welcometoslam",this.HomeUID,"X"}
	Object.SetProperty(this,"UsingSmallField",UseSmallField)
	Object.SetProperty(this,"PLAYGAME","OFF")
	Object.SetProperty(this,"BallKillOrDelete","deleted")
	Object.SetProperty(this,"CourtLights","OFF")
	Object.SetProperty(this,"DebugInfo","OFF")
	Object.SetProperty(this,"numLine",numLine)
	Object.SetProperty(this,"StillAsleep",true)
	Object.SetProperty(this,"hasStarted",false)
	Object.SetProperty(this,"LeftGoalMade",false)
	Object.SetProperty(this,"RightGoalMade",false)
	Object.SetProperty(this,"TeacherBringToCentre",false)
	Object.SetProperty(this,"TeacherStartingGame",false)
	Object.SetProperty(this,"TickTockTimer",1)
	if this.UsingSmallField==false then
		
		if this.Or.x==0 then
			Object.SetProperty(this,"Xmin",-8)	Object.SetProperty(this,"Xmax",7)	Object.SetProperty(this,"Ymin",-5)	Object.SetProperty(this,"Ymax",4)
		elseif this.Or.y==0 then
			Object.SetProperty(this,"Xmin",-5)	Object.SetProperty(this,"Xmax",4)	Object.SetProperty(this,"Ymin",-8)	Object.SetProperty(this,"Ymax",7)
		end
	else
		if this.Or.x==0 and this.Or.y==1 then
			Object.SetProperty(this,"Xmin",-8)	Object.SetProperty(this,"Xmax",-1)	Object.SetProperty(this,"Ymin",-5)	Object.SetProperty(this,"Ymax",4)
		elseif this.Or.x==1 and this.Or.y==0 then
			Object.SetProperty(this,"Xmin",-5)	Object.SetProperty(this,"Xmax",4)	Object.SetProperty(this,"Ymin",0)	Object.SetProperty(this,"Ymax",7)
		elseif this.Or.x==0 and this.Or.y==-1 then
			Object.SetProperty(this,"Xmin",0)	Object.SetProperty(this,"Xmax",7)	Object.SetProperty(this,"Ymin",-5)	Object.SetProperty(this,"Ymax",4)
		elseif this.Or.x==-1 and this.Or.y==0 then
			Object.SetProperty(this,"Xmin",-5)	Object.SetProperty(this,"Xmax",4)	Object.SetProperty(this,"Ymin",-8)	Object.SetProperty(this,"Ymax",-1)
		end
	end
	
	if this.UsingSmallField==false then

		if this.Or.x==0 then  -- horizontal large court
					
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x-4.90000,this.Pos.y) --left field
	
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x-7.00000,this.Pos.y)
			Object.SetProperty(myLeftGoal,"Or.x",-1)	Object.SetProperty(myLeftGoal,"Or.y",0)
			
			myRightField = Object.Spawn("BasketballFieldRight", this.Pos.x+4.90000,this.Pos.y) --right field
			Object.SetProperty(myRightField, "Or.x", 0)		Object.SetProperty(myRightField, "Or.y", -1)	
		
			myRightGoal = Object.Spawn("StatusLight", this.Pos.x+7.00000,this.Pos.y)
			Object.SetProperty(myRightGoal,"Or.x",1)	Object.SetProperty(myRightGoal,"Or.y",0)
			
			myScoreBoard = Object.Spawn("ScoreBoard", this.Pos.x, this.Pos.y-5.750000)
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x+0.5, this.Pos.y-5.25)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x+1, this.Pos.y-5.25)
			myScoreDash =  Object.Spawn("LEDNumber", this.Pos.x, this.Pos.y-5.25)
			myRightScoreTens =  Object.Spawn("LEDNumber", this.Pos.x-1, this.Pos.y-5.25)
			myRightScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x-0.5, this.Pos.y-5.25)
			
		elseif this.Or.y==0 then  --vertical large court
			
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x,this.Pos.y-4.90000) --left field
			Object.SetProperty(myLeftField,"Or.x",-1)		Object.SetProperty(myLeftField,"Or.y",0)
			
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y-7.00000)
			Object.SetProperty(myLeftGoal,"Or.x",0)		Object.SetProperty(myLeftGoal,"Or.y",-1)
			
			myRightField = Object.Spawn("BasketballFieldRight", this.Pos.x,this.Pos.y+4.90000) --right field
			Object.SetProperty(myRightField, "Or.x", 1)		Object.SetProperty(myRightField, "Or.y", 0)
			
			myRightGoal = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y+7.00000)
			Object.SetProperty(myRightGoal,"Or.x",0)	Object.SetProperty(myRightGoal,"Or.y",1)
			
			myScoreBoard = Object.Spawn("ScoreBoard", this.Pos.x, this.Pos.y-8.750000)
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x+0.5, this.Pos.y-8.25)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x+1, this.Pos.y-8.25)
			myScoreDash =  Object.Spawn("LEDNumber", this.Pos.x, this.Pos.y-8.25)
			myRightScoreTens =  Object.Spawn("LEDNumber", this.Pos.x-1, this.Pos.y-8.25)
			myRightScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x-0.5, this.Pos.y-8.25)
		end
		
		Object.SetProperty(myScoreBoard,"HomeUID",this.HomeUID)
		myScoreBoard.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"
		
		Object.SetProperty(myRightField,"HomeUID",this.HomeUID)
		myRightField.Tooltip={"tooltip_linktogoal",myRightField.HomeUID,"X"}
		
		Object.SetProperty(myRightGoal,"HomeUID",this.HomeUID)
		Object.SetProperty(myRightGoal,"LeftGoal","no")	Object.SetProperty(myRightGoal,"RightGoal","yes")
		myRightGoal.Tooltip={"tooltip_linkedto",myRightGoal.HomeUID,"X"}
		
		Object.SetProperty(this,"LeftScore",0)	Object.SetProperty(this,"RightScore",0)		
		
		Object.SetProperty(myLeftScoreTens,"HomeUID",this.HomeUID)
		Object.SetProperty(myLeftScoreTens,"PlaceValue","Tens")
		Object.SetProperty(myLeftScoreTens,"LeftGoal","yes")	Object.SetProperty(myLeftScoreTens,"RightGoal","no")
		
		Object.SetProperty(myLeftScoreUnits,"HomeUID",this.HomeUID)
		Object.SetProperty(myLeftScoreUnits,"PlaceValue","Units")
		Object.SetProperty(myLeftScoreUnits,"LeftGoal","yes")	Object.SetProperty(myLeftScoreUnits,"RightGoal","no")
		
		Object.SetProperty(myScoreDash,"HomeUID",this.HomeUID)
		Object.SetProperty(myScoreDash,"SubType",10)
		Object.SetProperty(myScoreDash,"myScore",10)
		Object.SetProperty(myScoreDash,"PlaceValue","Dash")
		Object.SetProperty(myScoreDash,"LeftGoal","no")	Object.SetProperty(myScoreDash,"RightGoal","yes")
		
		Object.SetProperty(myRightScoreTens,"HomeUID",this.HomeUID)
		Object.SetProperty(myRightScoreTens,"PlaceValue","Tens")
		Object.SetProperty(myRightScoreTens,"LeftGoal","no")	Object.SetProperty(myRightScoreTens,"RightGoal","yes")
		
		Object.SetProperty(myRightScoreUnits,"HomeUID",this.HomeUID)
		Object.SetProperty(myRightScoreUnits,"PlaceValue","Units")
		Object.SetProperty(myRightScoreUnits,"LeftGoal","no")	Object.SetProperty(myRightScoreUnits,"RightGoal","yes")

		myLeftScoreTens.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"
		myRightScoreTens.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"
		myLeftScoreUnits.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"
		myRightScoreUnits.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"
		myScoreDash.Tooltip="buildtoolbar_popup_obj_ScoreBoardLeague"

		myCentreLight = Object.Spawn("Light", this.Pos.x, this.Pos.y)
		
	else -- small court
	
		if this.Or.x==0 and this.Or.y==1 then	-- placed down
			
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x-5,this.Pos.y) --left field
			
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x-7,this.Pos.y)
			Object.SetProperty(myLeftGoal,"Or.x",-1)
			Object.SetProperty(myLeftGoal,"Or.y",0)
			
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x-8.75, this.Pos.y)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x-8.25, this.Pos.y)
			
			myCentreLight = Object.Spawn("Light", this.Pos.x-0.2, this.Pos.y)
			
		elseif this.Or.x==-1 and this.Or.y==0 then	-- rotated once
			
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x,this.Pos.y-5) --left field
			Object.SetProperty(myLeftField,"Or.x",-1)		Object.SetProperty(myLeftField,"Or.y",0)
			
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y-7)
			Object.SetProperty(myLeftGoal,"Or.x",0)
			Object.SetProperty(myLeftGoal,"Or.y",-1)
			
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x-0.25, this.Pos.y-8.5)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x+0.25, this.Pos.y-8.5)
			
			myCentreLight = Object.Spawn("Light", this.Pos.x, this.Pos.y-0.2)
			
		elseif this.Or.x==0 and this.Or.y==-1 then	-- rotated twice
			
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x+5,this.Pos.y) --left field
			Object.SetProperty(myLeftField,"Or.x",0)		Object.SetProperty(myLeftField,"Or.y",-1)
			
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x+7,this.Pos.y)
			Object.SetProperty(myLeftGoal,"Or.x",1)
			Object.SetProperty(myLeftGoal,"Or.y",0)
			
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x+8.25, this.Pos.y)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x+8.75, this.Pos.y)
			
			myCentreLight = Object.Spawn("Light", this.Pos.x+0.2, this.Pos.y)
			
		elseif this.Or.x==1 and this.Or.y==0 then	-- rotated three times
			
			myLeftField = Object.Spawn("BasketballFieldLeft", this.Pos.x,this.Pos.y+5) --left field
			Object.SetProperty(myLeftField,"Or.x",1)		Object.SetProperty(myLeftField,"Or.y",0)
			
			myLeftGoal = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y+7)
			Object.SetProperty(myLeftGoal,"Or.x",0)
			Object.SetProperty(myLeftGoal,"Or.y",1)
			
			myLeftScoreTens =  Object.Spawn("LEDNumber", this.Pos.x-0.25, this.Pos.y+8.5)
			myLeftScoreUnits =  Object.Spawn("LEDNumber", this.Pos.x+0.25, this.Pos.y+8.5)
			
			myCentreLight = Object.Spawn("Light", this.Pos.x, this.Pos.y+0.2)
			
		end
		
		Object.SetProperty(myLeftScoreTens,"HomeUID",this.HomeUID)
		Object.SetProperty(myLeftScoreTens,"PlaceValue","Tens")
		Object.SetProperty(myLeftScoreTens,"LeftGoal","yes")	Object.SetProperty(myLeftScoreTens,"RightGoal","no")
		
		Object.SetProperty(myLeftScoreUnits,"HomeUID",this.HomeUID)
		Object.SetProperty(myLeftScoreUnits,"PlaceValue","Units")
		Object.SetProperty(myLeftScoreUnits,"LeftGoal","yes")	Object.SetProperty(myLeftScoreUnits,"RightGoal","no")
		
		myLeftScoreTens.Tooltip="buildtoolbar_popup_obj_ScoreBoardTraining"
		myLeftScoreUnits.Tooltip="buildtoolbar_popup_obj_ScoreBoardTraining"
		
		Object.SetProperty(this,"LeftScore",0)
	end
	
	Object.SetProperty(myCentreLight,"HomeUID",this.HomeUID)
	
	Object.SetProperty(myLeftField,"HomeUID",this.HomeUID)
	Object.SetProperty(myLeftGoal,"HomeUID",this.HomeUID)
	Object.SetProperty(myLeftGoal,"LeftGoal","yes")
	Object.SetProperty(myLeftGoal,"RightGoal","no")
	
	myLeftField.Tooltip={"tooltip_linktogoal",myLeftField.HomeUID,"X"}
	myLeftGoal.Tooltip={"tooltip_linkedto",myLeftGoal.HomeUID,"X"}
	
	timePerUpdate=1440
	
	Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_button_delete")
	Interface.AddComponent(this,"","Caption","tooltip_courtconfig")
	Interface.AddComponent(this,"toggleGame", "Button", "tooltip_button_game","tooltip_off","X")
	Interface.AddComponent(this,"toggleDeleteOrKillBall", "Button", "tooltip_button_balldelkill","tooltip_del","X")
	Interface.AddComponent(this,"toggleFloorType", "Button", "tooltip_button_floortype",FloorDescription[numFloor],"X")
	Interface.AddComponent(this,"toggleLineType", "Button", "tooltip_button_linetype",this.numLine,"X")
	Interface.AddComponent(this,"toggleCourtLights", "Button", "tooltip_button_courtlights","tooltip_off","X")
	--Interface.AddComponent(this,"toggleDebugInfo", "Button", "tooltip_button_debuginfo","tooltip_off","X")  -- debuginfo is disabled for now because the script debugger is crap in PA 2.0. To enable debuginfo, manually set DebugInfo to ON in the savedgame.
	--MakeFloor(FloorTypes[numFloor])
end

----------------------------------------------------------------------------------------------------------------------------------
--  Buttons
----------------------------------------------------------------------------------------------------------------------------------

function toggleGameClicked()
	if this.PLAYGAME=="ON" then
		Object.SetProperty(this,"PLAYGAME","OFF")
		Object.SetProperty(this,"StillAsleep",false)
		DoSleepMode()
		Object.SetProperty(myLeftScoreTens,"SubType",10)
		Object.SetProperty(myLeftScoreUnits,"SubType",10)
		Object.SetProperty(myLeftScoreTens,"myScore",10)
		Object.SetProperty(myLeftScoreUnits,"myScore",10)
		if this.UsingSmallField==false then
			Object.SetProperty(this,"RightGoalMade",false)
			Object.SetProperty(this,"RightScore",0)
			Object.SetProperty(myRightScoreTens,"SubType",10)
			Object.SetProperty(myRightScoreUnits,"SubType",10)
			Object.SetProperty(myRightScoreTens,"myScore",10)
			Object.SetProperty(myRightScoreUnits,"myScore",10)
		end
		if this.DebugInfo=="ON" then print("GAME OFF - Going into deep sleep mode") end
		this.Tooltip={"tooltip_deepsleep",this.HomeUID,"X"}
		this.SetInterfaceCaption("toggleGame", "tooltip_button_game","tooltip_off","X")
		Interface.AddComponent(this,"toggleCourtLights", "Button", "tooltip_button_courtlights","tooltip_off","X")
		timePerUpdate=1440
	else
		this.SetInterfaceCaption("toggleGame", "tooltip_button_game","tooltip_on","X")
		if this.CourtLights=="ON" then toggleCourtLightsClicked() end
		Interface.RemoveComponent(this,"toggleCourtLights", "Button", "tooltip_button_courtlights","tooltip_off","X")
		Object.SetProperty(this,"PLAYGAME","ON")
		if this.UsingSmallField==false then
			this.Tooltip={"tooltip_fullcourtwelcome",this.HomeUID,"X"}
		else
			this.Tooltip={"tooltip_halfcourtwelcome",this.HomeUID,"X"}
		end
		FindMyFields()
		FindMyScoreBoard()
		FindMyCourtLights()
		FindMyGoals()
		timePerUpdate=2
	end	
end

function toggleFloorTypeClicked()
	numFloor=numFloor+1
	if numFloor>18 then	numFloor=1	end
	Object.SetProperty(this,"numFloor",numFloor)
	this.SetInterfaceCaption("toggleFloorType", "tooltip_button_floortype",FloorDescription[this.numFloor],"X")
	MakeFloor(FloorTypes[numFloor])
end

function toggleLineTypeClicked()
	numLine=numLine+1
	if numLine>9 then	numLine=0	end
	Object.SetProperty(this,"numLine",numLine)
	Object.SetProperty(myLeftField,"SubType",numLine)
	Object.SetProperty(myRightField,"SubType",numLine)
	this.SetInterfaceCaption("toggleLineType", "tooltip_button_linetype",this.numLine,"X")
end

function toggleCourtLightsClicked()  -- courtlights can only be toggled on/off manually when GAME OFF. The game will toggle lights on/off automatically when game starts/stops.
	if this.CourtLights=="ON" then
		Object.SetProperty(this,"CourtLights","OFF")	LightsOff()
		this.SetInterfaceCaption("toggleCourtLights", "tooltip_button_courtlights","tooltip_off","X")
	else
		Object.SetProperty(this,"CourtLights","ON")		LightsOn()
		this.SetInterfaceCaption("toggleCourtLights", "tooltip_button_courtlights","tooltip_on","X")
	end
end

function toggleDebugInfoClicked()  -- debuginfo is disabled for now because the script debugger is crap in PA 2.0. To enable debuginfo, manually set DebugInfo to ON in the savedgame.
	if this.DebugInfo=="ON" then
		Object.SetProperty(this,"DebugInfo","OFF")	print("DebugInfo: OFF")
		this.SetInterfaceCaption("toggleDebugInfo", "tooltip_button_debuginfo","tooltip_off","X")
	else
		Object.SetProperty(this,"DebugInfo","ON")	print("DebugInfo: ON")
		this.SetInterfaceCaption("toggleDebugInfo", "tooltip_button_debuginfo","tooltip_on","X")
		print("The error below was made intentionally to open this window by itself:")
		local dummyBo0lean=false
		Game.DebugOut(""..dummyBo0lean.."")
	end
end

function toggleDeleteOrKillBallClicked()
	if this.BallKillOrDelete=="deleted" then
		Object.SetProperty(this,"BallKillOrDelete","killed")
		this.SetInterfaceCaption("toggleDeleteOrKillBall", "tooltip_button_balldelkill","tooltip_kill","X")
		print("Ball gets killed after a match")
	else
		Object.SetProperty(this,"BallKillOrDelete","deleted")
		this.SetInterfaceCaption("toggleDeleteOrKillBall", "tooltip_button_balldelkill","tooltip_del","X")
		print("Ball gets deleted after a match")
	end
end

function toggleDeleteClicked()
	if this.PLAYGAME=="OFF" then toggleGameClicked() end
	DismantleAll()
end

----------------------------------------------------------------------------------------------------------------------------------
--  Sleep or Wake up
----------------------------------------------------------------------------------------------------------------------------------

function DoWakeUpMode()
	if this.DebugInfo=="ON" then print("Waking up") end
	this.Tooltip={"tooltip_gettingready",this.HomeUID,"X"}
	timePerUpdate=2
	Object.SetProperty(this,"LeftScore",0)
	if ScoreFound==true then
		Object.SetProperty(myLeftScoreTens,"SubType",0)
		Object.SetProperty(myLeftScoreUnits,"SubType",0)
		Object.SetProperty(myLeftScoreTens,"myScore",0)
		Object.SetProperty(myLeftScoreUnits,"myScore",0)
		if this.UsingSmallField==false then
			Object.SetProperty(this,"RightScore",0)
			Object.SetProperty(myRightScoreTens,"SubType",0)
			Object.SetProperty(myRightScoreUnits,"SubType",0)
			Object.SetProperty(myRightScoreTens,"myScore",0)
			Object.SetProperty(myRightScoreUnits,"myScore",0)
		end
	end
	Object.SetProperty(this,"StillAsleep",false)
end

function DoSleepMode()
	if this.StillAsleep==false then
		if this.UsingSmallField==false then
			if this.DebugInfo=="ON" then print("Score for this match was: "..this.LeftScore.." - "..this.RightScore.."") end
		else
			if this.DebugInfo=="ON" then print("Score for this match was: "..this.LeftScore.."") end
		end
		if this.DebugInfo=="ON" then print("Going back to sleep") end
		this.Tooltip={"tooltip_sleepmode",this.HomeUID,"X"}
		timePerUpdate=10
		BallJobCreated=false
		TeacherFound=false
		this.Sound("BasketballCourt","WhistleB")
		this.Sound("BasketballCourt","WhistleB")
		this.Sound("BasketballCourt","WhistleB")
		this.Sound("BasketballCourt","WhistleB")
		Object.SetProperty(this,"StillAsleep",true)
		Object.SetProperty(this,"hasStarted",false)
		Object.SetProperty(this,"LeftGoalMade",false)
		Object.SetProperty(this,"LeftScore",0)
		if this.UsingSmallField==false then
			Object.SetProperty(this,"RightGoalMade",false)
			Object.SetProperty(this,"RightScore",0)
			if ScoreFound==true then
				Object.SetProperty(myRightScoreTens,"SubType",0)
				Object.SetProperty(myRightScoreUnits,"SubType",0)
				Object.SetProperty(myRightScoreTens,"myScore",0)
				Object.SetProperty(myRightScoreUnits,"myScore",0)
			end
		end
		Object.SetProperty(this,"TeacherBringToCentre",false)
		Object.SetProperty(this,"TeacherStartingGame",false)
		Object.SetProperty(this,"TickTockTimer",1)
		if ScoreFound==true then
			Object.SetProperty(myLeftScoreTens,"SubType",0)
			Object.SetProperty(myLeftScoreUnits,"SubType",0)
			Object.SetProperty(myLeftScoreTens,"myScore",0)
			Object.SetProperty(myLeftScoreUnits,"myScore",0)
		end
		if BallFound==true then
			BallFound=false
			Object.SetProperty(myBall,"Carried",0)
			Object.SetProperty(myBall,"NewPosX","")
			Object.SetProperty(myBall,"NewPosY","")
			Object.SetProperty(myBall,"CarrierId.i",0)
			Object.SetProperty(myBall,"CarrierId.u",0)
			Object.SetProperty(myCurrentPlayer,"Carrying.i",0)
			Object.SetProperty(myCurrentPlayer,"Carrying.u",0)
			Object.SetProperty(myNewPlayer,"Carrying.i",0)
			Object.SetProperty(myNewPlayer,"Carrying.u",0)
			Object.SetProperty(myTeacher,"Carrying.i",0)
			Object.SetProperty(myTeacher,"Carrying.u",0)
			if this.BallKillOrDelete=="deleted" then
				if this.DebugInfo=="ON" then print("Deleting the basketball") end
				myBall.Delete()
			else
				if this.DebugInfo=="ON" then print("Killing the basketball") end
				myBall.Damage=1
			end
			myBall=nil
		end
		LightsOff()
	end
end

----------------------------------------------------------------------------------------------------------------------------------
--  Update
----------------------------------------------------------------------------------------------------------------------------------		
			  
function Update( timePassed )
	if this.BallKillOrDelete==nil then FindMyFields() DismantleAll() end
	if timePerUpdate==nil then

		if this.CreateMyField=="ON" then CreateMyField() Object.SetProperty(this,"CreateMyField","OFF") end
		
		Interface.AddComponent(this,"toggleDelete", "Button", "tooltip_button_delete")
		Interface.AddComponent(this,"","Caption","tooltip_courtconfig")
		
		FindMyFields() -- find all the stuff here to update the tooltips correctly when loading game
		FindMyScoreBoard()
		FindMyGoals()

		if this.PLAYGAME=="ON" then
			Interface.AddComponent(this,"toggleGame", "Button", "tooltip_button_game","tooltip_on","X")
			if this.UsingSmallField==false then
				this.Tooltip={"tooltip_fullcourtwelcome",this.HomeUID,"X"}
			else
				this.Tooltip={"tooltip_halfcourtwelcome",this.HomeUID,"X"}
			end
		else
			Object.SetProperty(myLeftScoreTens,"SubType",10) -- put scoreboard numbers back to sleep after finding the stuff when loading game
			Object.SetProperty(myLeftScoreUnits,"SubType",10)
			Object.SetProperty(myLeftScoreTens,"myScore",10)
			Object.SetProperty(myLeftScoreUnits,"myScore",10)
			if this.UsingSmallField==false then
				Object.SetProperty(myRightScoreTens,"SubType",10)
				Object.SetProperty(myRightScoreUnits,"SubType",10)
				Object.SetProperty(myRightScoreTens,"myScore",10)
				Object.SetProperty(myRightScoreUnits,"myScore",10)
			end
			this.Tooltip={"tooltip_deepsleep",this.HomeUID,"X"}
			Interface.AddComponent(this,"toggleGame", "Button", "tooltip_button_game","tooltip_off","X")
		end

		if this.BallKillOrDelete=="deleted" then
			Interface.AddComponent(this,"toggleDeleteOrKillBall", "Button", "tooltip_button_balldelkill","tooltip_del","X")
		else
			Interface.AddComponent(this,"toggleDeleteOrKillBall", "Button", "tooltip_button_balldelkill","tooltip_kill","X")
		end
		
		if this.numFloor~=nil then
			numFloor=this.numFloor
			Interface.AddComponent(this,"toggleFloorType", "Button", "tooltip_button_floortype",FloorDescription[this.numFloor],"X")
		else
			Object.SetProperty(this,"numFloor",1)
			Interface.AddComponent(this,"toggleFloorType", "Button", "tooltip_button_floortype",FloorDescription[this.numFloor],"X")
		end

		if this.numLine~=nil then
			numLine=this.numLine
			Interface.AddComponent(this,"toggleLineType", "Button", "tooltip_button_linetype",this.numLine,"X")
		else
			Object.SetProperty(this,"numLine",0)
			Interface.AddComponent(this,"toggleLineType", "Button", "tooltip_button_linetype",this.numLine,"X")
		end

		if this.PLAYGAME=="OFF" then
			if this.CourtLights=="ON" then
				Interface.AddComponent(this,"toggleCourtLights", "Button", "tooltip_button_courtlights","tooltip_on","X")
			else
				Interface.AddComponent(this,"toggleCourtLights", "Button", "tooltip_button_courtlights","tooltip_off","X")
			end
		end
		
		if this.DebugInfo=="ON" then
			Interface.AddComponent(this,"toggleDebugInfo", "Button", "tooltip_button_debuginfo","tooltip_on","X")
--		else
--			Interface.AddComponent(this,"toggleDebugInfo", "Button", "tooltip_button_debuginfo","tooltip_off","X")  -- debuginfo is disabled for now because the script debugger is crap in PA 2.0. To enable debuginfo, manually set DebugInfo to ON in the savedgame.
		end
		FindMyCourtLights()
		if this.PLAYGAME=="ON" then
			FindMyBall()
			FindMyTeacher()
			if BallFound==true then
				if myBall.Carried>0 then
					local ballPlayers = Object.GetNearbyObjects(myBall,'Prisoner',3)
					if next(ballPlayers) then
						for thatprisoner,dist in pairs( ballPlayers ) do
							if thatprisoner.Id.i==myBall.CarrierId.i and thatprisoner.Id.u==myBall.CarrierId.u then
								if this.DebugInfo=="ON" then print("Current player found") end
								myCurrentPlayer=thatprisoner
								if this.DebugInfo=="ON" then print("               Removing carried from "..myCurrentPlayer.Id.i.."") end
								Object.SetProperty(myBall,"Carried",0)
								Object.SetProperty(myBall,"NewPosX","")				Object.SetProperty(myBall,"NewPosY","")
								Object.SetProperty(myBall,"CarrierId.i",0)			Object.SetProperty(myBall,"CarrierId.u",0)
								Object.SetProperty(myCurrentPlayer,"Carrying.i",0)	Object.SetProperty(myCurrentPlayer,"Carrying.u",0)
								break
							end
						end
					end
				end	
				Object.SetProperty(this,"TickTockTimer",4)
				Object.SetProperty(this,"hasStarted",false)
				timePerUpdate=2
			else
				timePerUpdate=10
				if this.UsingSmallField==false then
					this.Tooltip={"tooltip_fullcourtwelcome",this.HomeUID,"X"}
				else
					this.Tooltip={"tooltip_halfcourtwelcome",this.HomeUID,"X"}
				end
			end
		else
			timePerUpdate=1440
		end
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
				
		if this.PLAYGAME=="ON" then
		
			if FieldsFound==false then
				FindMyFields()
			end
			if GoalsFound==false then
				FindMyGoals()
			end
			
			if FieldsFound==true and GoalsFound==true then

				CheckNumPlayers()

				if this.hasStarted==true then
					if this.DebugInfo=="ON" then print("TickTockTimer: "..this.TickTockTimer.."") end
					if this.LeftGoalMade==false and this.RightGoalMade==false then
						if this.TickTockTimer<4 then
							BounceBall()
						else
							if this.DebugInfo=="ON" then print("TickTockTimer is more than 3, Basketball Trainer required") end
							Object.SetProperty(this,"hasStarted",false)
							this.Sound("BasketballCourt","WhistleA")
							this.Sound("BasketballCourt","WhistleB")
							this.Sound("BasketballCourt","WhistleA")
							this.Sound("BasketballCourt","WhistleB")
							SpawnBallX=myBall.Pos.x
							SpawnBallY=myBall.Pos.y
							myBall.Delete()
							SpawnNewBall(5)
						end
					else
						if this.TickTockTimer<=4 then
							if this.DebugInfo=="ON" then print("Player tried to make a goal") end
							DoGoal()
						else
							if this.DebugInfo=="ON" then print("Goal failed") end
							SpawnBallX=myBall.Pos.x
							SpawnBallY=myBall.Pos.y
							myBall.Delete()
							myBall=nil
							SpawnNewBall(5)
							Object.SetProperty(this,"hasStarted",false)
						end
					end
				end
			end
		end
	end
end

function DoGoal()
	if myBall.Loaded==true and this.LeftGoalMade==true then
		Object.SetProperty(myLeftGoal,"Triggered",5)
		this.Sound("BasketballCourt","WhistleB")
		Object.SetProperty(myLeftGoal,"Triggered",5)
		this.Sound("BasketballCourt","WhistleB")
		Object.SetProperty(myLeftGoal,"Triggered",5)
		this.Sound("BasketballCourt","WhistleA")
		Object.SetProperty(myLeftGoal,"Triggered",5)
		if this.DebugInfo=="ON" then print("               GOAL!!!") end
		if leftGoalDistance<=GoalDistance-3 then
			Object.SetProperty(this,"LeftScore",this.LeftScore+1)		-- one points goal
		elseif leftGoalDistance<=GoalDistance-1.1 then
			Object.SetProperty(this,"LeftScore",this.LeftScore+2)		-- two points goal
		else
			Object.SetProperty(this,"LeftScore",this.LeftScore+3)		-- three points goal
		end
		if this.UsingSmallField==false then
			if this.DebugInfo=="ON" then print("               Score: "..this.RightScore.." - "..this.LeftScore.."") end
			this.Tooltip={"tooltip_fullcourtgoal",this.HomeUID,"X",this.RightScore,"Y",this.LeftScore,"Z"}
		else
			if this.DebugInfo=="ON" then print("               Score: "..this.LeftScore.."") end
			this.Tooltip={"tooltip_halfcourtgoal",this.HomeUID,"X",this.LeftScore,"Y"}
		end
		if ScoreFound==true then 
			if this.LeftScore<10 then
				Object.SetProperty(myLeftScoreTens,"SubType",0)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore)
			elseif this.LeftScore<20 then
				Object.SetProperty(myLeftScoreTens,"SubType",1)		Object.SetProperty(myLeftScoreTens,"myScore",1)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-10)
			elseif this.LeftScore<30 then
				Object.SetProperty(myLeftScoreTens,"SubType",2)		Object.SetProperty(myLeftScoreTens,"myScore",2)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-20)
			elseif this.LeftScore<40 then
				Object.SetProperty(myLeftScoreTens,"SubType",3)		Object.SetProperty(myLeftScoreTens,"myScore",3)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-30)
			elseif this.LeftScore<50 then
				Object.SetProperty(myLeftScoreTens,"SubType",4)		Object.SetProperty(myLeftScoreTens,"myScore",4)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-40)
			elseif this.LeftScore<60 then
				Object.SetProperty(myLeftScoreTens,"SubType",5)		Object.SetProperty(myLeftScoreTens,"myScore",5)		Object.SetProperty(myLeftScoreUnits,"myScore",this.LeftScore-50)
			end
		end			
		Object.SetProperty(myLeftField,"Triggered",2)
		Object.SetProperty(this,"hasStarted",false)
		Object.SetProperty(this,"TickTockTimer",4)
	elseif myBall.Loaded==true and this.RightGoalMade==true then
		Object.SetProperty(myRightGoal,"Triggered",5)
		this.Sound("BasketballCourt","WhistleB")
		Object.SetProperty(myRightGoal,"Triggered",5)
		this.Sound("BasketballCourt","WhistleB")
		Object.SetProperty(TimeIndex,"Triggered",5)
		this.Sound("BasketballCourt","WhistleA")
		Object.SetProperty(myRightGoal,"Triggered",5)
		if this.DebugInfo=="ON" then print("               GOAL!!!") end
		if rightGoalDistance<=GoalDistance-3 then
			Object.SetProperty(this,"RightScore",this.RightScore+1)		-- one points goal
		elseif rightGoalDistance<=GoalDistance-1.1 then
			Object.SetProperty(this,"RightScore",this.RightScore+2)		-- two points goal
		else
			Object.SetProperty(this,"RightScore",this.RightScore+3)		-- three points goal
		end
		if this.DebugInfo=="ON" then print("               Score: "..this.RightScore.." - "..this.LeftScore.."") end
		this.Tooltip={"tooltip_fullcourtgoal",this.HomeUID,"X",this.RightScore,"Y",this.LeftScore,"Z"}
		if ScoreFound==true then
			if this.RightScore<10 then
				Object.SetProperty(myRightScoreTens,"SubType",0)	Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore)
			elseif this.RightScore<20 then
				Object.SetProperty(myRightScoreTens,"SubType",1)	Object.SetProperty(myRightScoreTens,"myScore",1)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-10)
			elseif this.RightScore<30 then
				Object.SetProperty(myRightScoreTens,"SubType",2)	Object.SetProperty(myRightScoreTens,"myScore",2)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-20)
			elseif this.RightScore<40 then
				Object.SetProperty(myRightScoreTens,"SubType",3)	Object.SetProperty(myRightScoreTens,"myScore",3)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-30)
			elseif this.RightScore<50 then
				Object.SetProperty(myRightScoreTens,"SubType",4)	Object.SetProperty(myRightScoreTens,"myScore",4)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-40)
			elseif this.RightScore<60 then
				Object.SetProperty(myRightScoreTens,"SubType",5)	Object.SetProperty(myRightScoreTens,"myScore",5)		Object.SetProperty(myRightScoreUnits,"myScore",this.RightScore-50)
			end
		end
		Object.SetProperty(myRightField,"Triggered",2)
		Object.SetProperty(this,"hasStarted",false)
		Object.SetProperty(this,"TickTockTimer",4)
	end
end

function DismantleAll()
	if this.UsingSmallField==nil then Object.SetProperty(this,"UsingSmallField", UseSmallField) end
	if FieldsFoundL==true then print("deleting left field") myLeftField.Delete() end
	if FieldsFoundR==true then print("deleting right field") myRightField.Delete() end
	if GoalsFoundL==true then print("deleting left goal") myLeftGoal.Delete() end
	if GoalsFoundR==true then print("deleting right goal") myRightGoal.Delete() end
	if ScoreFound==true then
		print("deleting scoreboard")
		myLeftScoreTens.Delete()
		myLeftScoreUnits.Delete()
		if this.UsingSmallField==false then
			if ScoreDashFound==true then myScoreDash.Delete() end
			if ScoreBoardFound==true then myScoreBoard.Delete() end
			myRightScoreTens.Delete()
			myRightScoreUnits.Delete()
		end
	end
	FindMyCourtLights() print("deleting court lights")
	if myCentreLight~=nil then myCentreLight.Delete() end
	LightsOff()
--	MakeFloor(FloorTypes[19])
	this.Delete()
end
